"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createCollection = void 0;
const generated_1 = require("../../generated");
const plugins_1 = require("../../plugins");
const externalPlugins_1 = require("../../plugins/externalPlugins");
const createCollection = (context, { plugins, ...args }) => {
    const firstPartyPlugins = [];
    const externalPlugins = [];
    plugins?.forEach((plugin) => {
        if ((0, externalPlugins_1.isExternalPluginType)(plugin)) {
            externalPlugins.push(plugin);
        }
        else {
            firstPartyPlugins.push(plugin);
        }
    });
    return (0, generated_1.createCollectionV2)(context, {
        ...args,
        plugins: firstPartyPlugins.map(plugins_1.pluginAuthorityPairV2),
        externalPlugins: externalPlugins.map(plugins_1.createExternalPluginInitInfo),
    });
};
exports.createCollection = createCollection;
//# sourceMappingURL=createCollection.js.map