"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.updateCollectionPlugin = void 0;
const generated_1 = require("../../generated");
const plugins_1 = require("../../plugins");
const updateCollectionPlugin = (context, { plugin, ...args }) => {
    if ((0, plugins_1.isExternalPluginType)(plugin)) {
        const plug = plugin;
        return (0, generated_1.updateCollectionExternalPluginV1)(context, {
            ...args,
            updateInfo: (0, plugins_1.createExternalPluginUpdateInfo)(plug),
            key: (0, plugins_1.externalPluginKeyToBase)(plug.key),
        });
    }
    return (0, generated_1.updateCollectionPluginV1)(context, {
        ...args,
        plugin: (0, plugins_1.createPluginV2)(plugin),
    });
};
exports.updateCollectionPlugin = updateCollectionPlugin;
//# sourceMappingURL=updateCollectionPlugin.js.map