import { BaseDataStore, BaseDataStoreInitInfoArgs, BaseDataStoreUpdateInfoArgs, ExternalPluginSchema, ExternalRegistryRecord } from '../generated';
import { ExternalPluginKey } from './externalPluginKey';
import { ExternalPluginManifest } from './externalPluginManifest';
import { BaseExternalPlugin } from './externalPlugins';
import { LifecycleChecks } from './lifecycleChecks';
import { PluginAuthority } from './pluginAuthority';
export type DataStore = Omit<BaseDataStore, 'dataAuthority'> & {
    dataAuthority: PluginAuthority;
    data?: any;
};
export type DataStorePlugin = BaseExternalPlugin & DataStore & {
    type: 'DataStore';
    dataAuthority: PluginAuthority;
};
export type DataStoreInitInfoArgs = Omit<BaseDataStoreInitInfoArgs, 'initPluginAuthority' | 'lifecycleChecks' | 'dataAuthority'> & {
    type: 'DataStore';
    initPluginAuthority?: PluginAuthority;
    lifecycleChecks?: LifecycleChecks;
    schema?: ExternalPluginSchema;
    dataAuthority: PluginAuthority;
};
export type DataStoreUpdateInfoArgs = Omit<BaseDataStoreUpdateInfoArgs, 'schema'> & {
    key: ExternalPluginKey;
    schema?: ExternalPluginSchema;
};
export declare function dataStoreInitInfoArgsToBase(d: DataStoreInitInfoArgs): BaseDataStoreInitInfoArgs;
export declare function dataStoreUpdateInfoArgsToBase(d: DataStoreUpdateInfoArgs): BaseDataStoreUpdateInfoArgs;
export declare function dataStoreFromBase(s: BaseDataStore, r: ExternalRegistryRecord, account: Uint8Array): DataStore;
export declare const dataStoreManifest: ExternalPluginManifest<DataStore, BaseDataStore, DataStoreInitInfoArgs, BaseDataStoreInitInfoArgs, DataStoreUpdateInfoArgs, BaseDataStoreUpdateInfoArgs>;
