import { PublicKey } from '@metaplex-foundation/umi';
import { ExtraAccount } from './extraAccount';
import { BaseLifecycleHook, BaseLifecycleHookInitInfoArgs, BaseLifecycleHookUpdateInfoArgs, ExternalPluginSchema, ExternalRegistryRecord } from '../generated';
import { LifecycleChecks } from './lifecycleChecks';
import { PluginAuthority } from './pluginAuthority';
import { BaseExternalPlugin } from './externalPlugins';
import { ExternalPluginManifest } from './externalPluginManifest';
import { ExternalPluginKey } from './externalPluginKey';
export type LifecycleHook = Omit<BaseLifecycleHook, 'extraAccounts' | 'dataAuthority'> & {
    extraAccounts?: Array<ExtraAccount>;
    dataAuthority?: PluginAuthority;
    data?: any;
};
export type LifecycleHookPlugin = BaseExternalPlugin & LifecycleHook & {
    type: 'LifecycleHook';
    hookedProgram: PublicKey;
};
export type LifecycleHookInitInfoArgs = Omit<BaseLifecycleHookInitInfoArgs, 'initPluginAuthority' | 'lifecycleChecks' | 'schema' | 'extraAccounts' | 'dataAuthority'> & {
    type: 'LifecycleHook';
    initPluginAuthority?: PluginAuthority;
    lifecycleChecks: LifecycleChecks;
    schema?: ExternalPluginSchema;
    extraAccounts?: Array<ExtraAccount>;
    dataAuthority?: PluginAuthority;
};
export type LifecycleHookUpdateInfoArgs = Omit<BaseLifecycleHookUpdateInfoArgs, 'lifecycleChecks' | 'extraAccounts' | 'schema'> & {
    key: ExternalPluginKey;
    lifecycleChecks?: LifecycleChecks;
    extraAccounts?: Array<ExtraAccount>;
    schema?: ExternalPluginSchema;
};
export declare function lifecycleHookInitInfoArgsToBase(l: LifecycleHookInitInfoArgs): BaseLifecycleHookInitInfoArgs;
export declare function lifecycleHookUpdateInfoArgsToBase(l: LifecycleHookUpdateInfoArgs): BaseLifecycleHookUpdateInfoArgs;
export declare function lifecycleHookFromBase(s: BaseLifecycleHook, r: ExternalRegistryRecord, account: Uint8Array): LifecycleHook;
export declare const lifecycleHookManifest: ExternalPluginManifest<LifecycleHook, BaseLifecycleHook, LifecycleHookInitInfoArgs, BaseLifecycleHookInitInfoArgs, LifecycleHookUpdateInfoArgs, BaseLifecycleHookUpdateInfoArgs>;
